Index: /BAORadio/libindi/libindi/libs/indibase/indiccd.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indiccd.h	(revision 504)
+++ /BAORadio/libindi/libindi/libs/indibase/indiccd.h	(revision 504)
@@ -0,0 +1,165 @@
+/*******************************************************************************
+  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+
+  This program is free software; you can redistribute it and/or modify it
+  under the terms of the GNU General Public License as published by the Free
+  Software Foundation; either version 2 of the License, or (at your option)
+  any later version.
+
+  This program is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+  more details.
+
+  You should have received a copy of the GNU General Public License along with
+  this program; if not, write to the Free Software Foundation, Inc., 59
+  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+
+  The full GNU General Public License is included in this distribution in the
+  file called LICENSE.
+*******************************************************************************/
+
+#ifndef INDI_CCD_H
+#define INDI_CCD_H
+
+#include "defaultdriver.h"
+
+#define FRAME_TYPE_LIGHT 0
+#define FRAME_TYPE_BIAS 1
+#define FRAME_TYPE_DARK 2
+#define FRAME_TYPE_FLAT 3
+
+class INDI::CCD : public INDI::DefaultDriver
+{
+    protected:
+
+        char *RawFrame;
+        int RawFrameSize;
+
+        //  Altho these numbers are indeed stored in the indi properties
+        //  It makes for much cleaner code if we have 'plain old number' copies
+        //  So, when we process messages, just update both
+
+        int XRes;   //  native resolution of the ccd
+        int YRes;   //  ditto
+        int SubX;   //  left side of the subframe we are requesting
+        int SubY;   //  top of the subframe requested
+        int SubW;   //  width of the subframe
+        int SubH;   //  height of the subframe
+        int BinX;   //  Binning requested in the x direction
+        int BinY;   //  Binning requested in the Y direction
+        float PixelSizex;   //  pixel size in microns, x direction
+        float PixelSizey;   //  pixel size in microns, y direction
+        bool SendCompressed;
+
+        bool HasSt4Port;
+
+        //  If the camera has a second ccd, or integrated guide head
+        //  we need information on that one too
+        bool HasGuideHead;
+        char *RawGuiderFrame;
+        int RawGuideSize;
+        int GXRes;  //  native resolution of the guide head
+        int GYRes;  //  native resolution
+        int GSubX;  //  left side of the guide image subframe
+        int GSubY;  //  top of the guide image subframe
+        int GSubW;  //  Width of the guide image
+        int GSubH;  //  Height of the guide image
+        float GPixelSizex;  //  phyiscal size of the guider pixels
+        float GPixelSizey;
+        bool GuiderCompressed;
+
+        int FrameType;
+
+
+    private:
+    public:
+        CCD();
+        virtual ~CCD();
+
+        //  A ccd needs to desribe the frame
+        //INumberVectorProperty CcdFrameNV;
+        //INumberVectorProperty CcdExposureNV;
+        //INumberVectorProperty CcdBinNV;
+        //INumberVectorProperty CcdPixelSizeNV;
+
+
+        INumberVectorProperty ImageFrameNV;
+        INumber ImageFrameN[4];
+
+        INumberVectorProperty ImageBinNV;
+        INumber ImageBinN[2];
+
+        INumberVectorProperty ImagePixelSizeNV;
+        INumber ImagePixelSizeN[6];
+
+        INumberVectorProperty ImageExposureNV;
+        INumber ImageExposureN[1];
+
+        //INumberVectorProperty ImageExposureReqNV;
+        //INumber ImageExposureReqN[1];
+
+        INumberVectorProperty GuiderFrameNV;
+        INumber GuiderFrameN[4];
+        INumberVectorProperty GuiderPixelSizeNV;
+        INumber GuiderPixelSizeN[6];
+        INumberVectorProperty GuiderExposureNV;
+        INumber GuiderExposureN[1];
+
+        ISwitch FrameTypeS[4];
+        ISwitchVectorProperty FrameTypeSV;
+
+
+        ISwitch CompressS[2];
+        ISwitchVectorProperty CompressSV;
+
+        ISwitch GuiderCompressS[2];
+        ISwitchVectorProperty GuiderCompressSV;
+
+
+        ISwitch GuiderVideoS[2];
+        ISwitchVectorProperty GuiderVideoSV;
+
+        INumber GuideNS[2];
+        INumberVectorProperty GuideNSV;
+        INumber GuideEW[2];
+        INumberVectorProperty GuideEWV;
+
+        IBLOB FitsB;
+        IBLOBVectorProperty FitsBV;
+
+        IBLOB GuiderB;
+        IBLOBVectorProperty GuiderBV;
+
+        virtual bool  initProperties();
+        virtual bool updateProperties();
+        virtual void ISGetProperties (const char *dev);
+
+        virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
+        virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
+
+        virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n) {return false;}
+
+
+        virtual int StartExposure(float duration);
+        virtual bool ExposureComplete();
+        virtual int StartGuideExposure(float duration);
+        virtual bool AbortGuideExposure();
+        virtual bool GuideExposureComplete();
+        virtual int uploadfile(void *fitsdata,int total);
+        virtual int sendPreview();
+
+        //  Handy functions for child classes
+        virtual int SetCCDParams(int x,int y,int bpp,float xf,float yf);
+        virtual int SetGuidHeadParams(int x,int y,int bpp,float xf,float yf);
+
+        virtual int GuideNorth(float);
+        virtual int GuideSouth(float);
+        virtual int GuideEast(float);
+        virtual int GuideWest(float);
+
+        virtual int SetFrameType(int);
+
+};
+
+#endif // INDI:CCD_H
Index: /BAORadio/libindi/libindi/libs/indibase/indidevice.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indidevice.cpp	(revision 504)
+++ /BAORadio/libindi/libindi/libs/indibase/indidevice.cpp	(revision 504)
@@ -0,0 +1,363 @@
+/*******************************************************************************
+  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+
+  This program is free software; you can redistribute it and/or modify it
+  under the terms of the GNU General Public License as published by the Free
+  Software Foundation; either version 2 of the License, or (at your option)
+  any later version.
+
+  This program is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+  more details.
+
+  You should have received a copy of the GNU General Public License along with
+  this program; if not, write to the Free Software Foundation, Inc., 59
+  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+
+  The full GNU General Public License is included in this distribution in the
+  file called LICENSE.
+*******************************************************************************/
+
+#include "IndiDevice.h"
+
+#include <string.h>
+
+IndiDevice *device=NULL;
+
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void ISGetProperties (const char *dev)
+{
+    //fprintf(stderr,"Enter ISGetProperties '%s'\n",dev);
+    if(device==NULL) {
+        //IDLog("Create device for %s\n",dev);
+        device=_create_device();
+        if(dev != NULL) {
+            //fprintf(stderr,"Calling setDeviceName %s\n",dev);
+            device->setDeviceName(dev);
+            //fprintf(stderr,"deviceName() returns  %s\n",device->deviceName());
+            //fprintf(stderr,"getDefaultName() returns  %s\n",device->getDefaultName());
+        } else {
+            //device->setDeviceName("junker");
+            device->setDeviceName(device->getDefaultName());
+        }
+        device->addConfigurationControl();
+        device->init_properties();
+    }
+    device->ISGetProperties(dev);
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n)
+{
+    //fprintf(stderr,"Enter ISNewSwitch %s\n",dev);
+
+    //ISInit();
+    //fprintf(stderr,"Calling Device->IsNewSwitch for device %0x\n",(void *)device);
+    device->ISNewSwitch(dev, name, states, names, n);
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n)
+{
+    //fprintf(stderr,"Enter ISNewText\n");
+    //ISInit();
+    device->ISNewText(dev, name, texts, names, n);
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n)
+{
+    //fprintf(stderr,"OutsideClass::Enter ISNewNumber\n");
+    //ISInit();
+    device->ISNewNumber(dev, name, values, names, n);
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void ISNewBLOB (const char *dev, const char *name, int sizes[], int blobsizes[], char *blobs[], char *formats[], char *names[], int n)
+{
+  INDI_UNUSED(dev);
+  INDI_UNUSED(name);
+  INDI_UNUSED(sizes);
+  INDI_UNUSED(blobsizes);
+  INDI_UNUSED(blobs);
+  INDI_UNUSED(formats);
+  INDI_UNUSED(names);
+  INDI_UNUSED(n);
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void ISSnoopDevice (XMLEle *root)
+{
+    return device->ISSnoopDevice(root);
+}
+
+void timerfunc(void *t)
+{
+    //fprintf(stderr,"Got a timer hit with %x\n",t);
+    if(t==device) {
+        //  this was for my device
+        //  but we dont have a way of telling
+        //  WHICH timer was hit :(
+        device->TimerHit();
+    }
+    return;
+}
+
+
+IndiDevice::IndiDevice()
+{
+    //ctor
+    Connected=false;
+}
+
+IndiDevice::~IndiDevice()
+{
+    //dtor
+}
+
+
+int IndiDevice::init_properties()
+{
+    //  All devices should have a connection switch defined
+    //  so lets create it
+
+    //IDLog("IndiDevice::init_properties()  MyDev=%s\n",deviceName());
+    IUFillSwitch(&ConnectionS[0],"CONNECT","Connect",ISS_OFF);
+    IUFillSwitch(&ConnectionS[1],"DISCONNECT","Disconnect",ISS_ON);
+    IUFillSwitchVector(&ConnectionSV,ConnectionS,2,deviceName(),"CONNECTION","Connection","Main Control",IP_RW,ISR_1OFMANY,60,IPS_IDLE);
+
+    return 0;
+}
+
+bool IndiDevice::DeleteProperty(char *n)
+{
+    IDDelete(deviceName(),n,NULL);
+    return true;
+}
+
+void IndiDevice::ISGetProperties(const char *dev)
+{
+
+    //  Now lets send the ones we have defined
+    //IDLog("IndiDevice::ISGetProperties %s\n",dev);
+    IDDefSwitch (&ConnectionSV, NULL);
+
+    if(Connected) UpdateProperties();   //  If already connected, send the rest
+    //  And now get the default driver to send what it wants to send
+    INDI::DefaultDriver::ISGetProperties(dev);
+
+
+}
+
+/**************************************************************************************
+** Process Text properties
+***************************************************************************************/
+bool IndiDevice::ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n)
+{
+
+    //  And this base class doesn't actually process anything
+    return INDI::DefaultDriver::ISNewText(dev,name,texts,names,n);
+}
+
+/**************************************************************************************
+**  Process Numbers
+***************************************************************************************/
+bool IndiDevice::ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n)
+{
+
+    //  Our base class doesn't actually do any processing
+    return INDI::DefaultDriver::ISNewNumber(dev,name,values,names,n);
+}
+
+/**************************************************************************************
+**  Process switches
+***************************************************************************************/
+bool IndiDevice::ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n)
+{
+
+    //  Ok, lets Process any switches we actually handle here
+    if(strcmp(dev,deviceName())==0) {
+        //  it's for this device
+
+        if(strcmp(name,ConnectionSV.name)==0) {
+                bool rc;
+                //IDLog("IndiDevice Switch %s\n",names[x]);
+
+                IUUpdateSwitch(&ConnectionSV,states,names,n);
+
+                if(ConnectionS[0].s==ISS_ON) {
+                    if(!Connected) {
+                        rc=Connect();
+                        if(rc) {
+                            ConnectionSV.s=IPS_OK;
+                            //setConnected(true,"calling setconnected");
+                            //ConnectionS[0].s=ISS_ON;
+                            //ConnectionS[1].s=ISS_OFF;
+                            Connected=true;
+                        } else {
+                            //ConnectionS[0].s=ISS_OFF;
+                            //ConnectionS[1].s=ISS_ON;
+                            ConnectionSV.s=IPS_ALERT;
+                            Connected=false;
+                        }
+                    }
+                    UpdateProperties();
+                    IDSetSwitch(&ConnectionSV,NULL);
+                } else {
+                    if(Connected) rc=Disconnect();
+                    //ConnectionS[0].s=ISS_OFF;
+                    //ConnectionS[1].s=ISS_ON;
+                    ConnectionSV.s=IPS_IDLE;
+                    Connected=false;
+                    UpdateProperties();
+                    IDSetSwitch(&ConnectionSV,NULL);
+                }
+
+                /*
+                if(strcmp(names[x],"CONNECT")==0) {
+                    //  We are being requested to make a physical connection to the device
+                    rc=Connect();
+                    if(rc) {
+                        //  Connection Succeeded
+                        ConnectionSV.s=IPS_OK;
+                        Connected=true;
+
+                    } else {
+                        //  Connection Failed
+                        ConnectionSV.s=IPS_ALERT;
+                        Connected=false;
+                    }
+                    IUUpdateSwitch(&ConnectionSV,states,names,n);
+                    IDSetSwitch(&ConnectionSV,NULL);
+                    IDLog("Connect ccalling update properties\n");
+                    UpdateProperties();
+                    //return true;
+                }
+                if(strcmp(names[x],"DISCONNECT")==0) {
+                    //  We are being told to disconnect from the device
+                    rc=Disconnect();
+                    if(rc) {
+                        ConnectionSV.s=IPS_IDLE;
+                    } else {
+                        ConnectionSV.s=IPS_ALERT;
+                    }
+                    Connected=false;
+                    IDLog("Disconnect calling update properties\n");
+                    UpdateProperties();
+                    //  And now lets tell everybody how it went
+                    IUUpdateSwitch(&ConnectionSV,states,names,n);
+                    IDSetSwitch(&ConnectionSV,NULL);
+                    return true;
+                }
+                */
+            //}
+        }
+    }
+
+
+    // let the default driver have a crack at it
+    return INDI::DefaultDriver::ISNewSwitch(dev, name, states, names, n);
+}
+
+//  This is a helper function
+//  that just encapsulates the Indi way into our clean c++ way of doing things
+int IndiDevice::SetTimer(int t)
+{
+    return IEAddTimer(t,timerfunc,this);
+}
+
+//  Just another helper to help encapsulate indi into a clean class
+void IndiDevice::RemoveTimer(int t)
+{
+    IERmTimer(t);
+    return;
+}
+//  This is just a placeholder
+//  This function should be overriden by child classes if they use timers
+//  So we should never get here
+void IndiDevice::TimerHit()
+{
+    return;
+}
+
+bool IndiDevice::Connect()
+{
+    //  We dont actually implement a device here
+    //  So we cannot connect to it
+    IDMessage(deviceName(),"IndiDevice:: has no device attached....");
+    return false;
+}
+
+bool IndiDevice::Disconnect()
+{
+    //  Since we cannot connect, we cant disconnect either
+    IDMessage(deviceName(),"IndiDevice:: has no device to detach....");
+    return false;
+}
+
+bool IndiDevice::UpdateProperties()
+{
+    //  The base device has no properties to update
+    return true;
+}
+
+void IndiDevice::ISSnoopDevice (XMLEle *root)
+{
+      INDI_UNUSED(root);
+}
+
+bool IndiDevice::SaveConfig()
+{
+
+    // FIXME REMOVE THIS
+    return true;
+
+    char err[MAXRBUF];
+    FILE *fp;
+    //int rc;
+
+    fp=IUGetConfigFP(NULL,deviceName(),err);
+    if(fp != NULL) {
+        IUSaveConfigTag(fp,0);
+        //IUSaveConfigText(fp,&FilterNameTV);
+        //  Tell child classes to write any items they want
+        //  into persistent storage
+        WritePersistentConfig(fp);
+        IUSaveConfigTag(fp,1);
+        fclose(fp);
+        //IDMessage(deviceName(),"Configuration Saved\n");
+        return true;
+    } else {
+        IDMessage(deviceName(),"Save config failed\n");
+    }
+    return false;
+}
+
+bool IndiDevice::WritePersistentConfig(FILE *f)
+{
+    return false;
+}
+
+bool IndiDevice::LoadConfig()
+{
+    char err[MAXRBUF];
+    int rc;
+
+    rc=IUReadConfig(NULL,deviceName(),err);
+    if(rc==0) return true;
+    return false;
+}
Index: /BAORadio/libindi/libindi/libs/indibase/indidevice.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indidevice.h	(revision 504)
+++ /BAORadio/libindi/libindi/libs/indibase/indidevice.h	(revision 504)
@@ -0,0 +1,86 @@
+/*******************************************************************************
+  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+
+  This program is free software; you can redistribute it and/or modify it
+  under the terms of the GNU General Public License as published by the Free
+  Software Foundation; either version 2 of the License, or (at your option)
+  any later version.
+
+  This program is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+  more details.
+
+  You should have received a copy of the GNU General Public License along with
+  this program; if not, write to the Free Software Foundation, Inc., 59
+  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+
+  The full GNU General Public License is included in this distribution in the
+  file called LICENSE.
+*******************************************************************************/
+#ifndef INDIDEVICE_H
+#define INDIDEVICE_H
+
+#include <libindi/indidevapi.h>
+#include <libindi/indicom.h>
+#include <libindi/defaultdriver.h>
+
+
+class IndiDevice : public INDI::DefaultDriver
+{
+
+    private:
+
+    protected:
+    public:
+        IndiDevice();
+        virtual ~IndiDevice();
+
+        //  These are the properties we define, that are generic to pretty much all devices
+        //  They are public to make them available to all dervied classes and thier children
+        ISwitchVectorProperty ConnectionSV; //  Vector of switches for our connection stuff
+        ISwitch ConnectionS[2];
+
+        //  Helper functions that encapsulate the indi way of doing things
+        //  and give us a clean c++ class method
+
+        virtual int init_properties();
+        //  This will be called after connecting
+        //  to flesh out and update properties to the
+        //  client when the device is connected
+        virtual bool UpdateProperties();
+
+        //  A helper for child classes
+        virtual bool DeleteProperty(char *);
+
+        //  A state variable applicable to all devices
+        //  and I cant get any intelligent result from the parent
+        //  class calling isConnected or setConnected, so, we wont use it
+        bool Connected;
+
+        int SetTimer(int);
+        void RemoveTimer(int);
+        virtual void TimerHit();
+
+        //  The function dispatchers required for all drivers
+        virtual void ISGetProperties (const char *dev);
+        virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
+        virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);
+        virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
+        virtual void ISSnoopDevice (XMLEle *root);
+
+        //  some virtual functions that our underlying classes are meant to override
+        virtual bool Connect();
+        virtual bool Disconnect();
+        virtual char *getDefaultName()=0;
+
+        virtual bool SaveConfig();
+        virtual bool LoadConfig();
+        virtual bool WritePersistentConfig(FILE *);
+
+};
+
+extern IndiDevice *device;
+extern IndiDevice *_create_device();
+
+#endif // INDIDEVICE_H
Index: /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.cpp	(revision 504)
+++ /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.cpp	(revision 504)
@@ -0,0 +1,194 @@
+/*******************************************************************************
+  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+
+  This program is free software; you can redistribute it and/or modify it
+  under the terms of the GNU General Public License as published by the Free
+  Software Foundation; either version 2 of the License, or (at your option)
+  any later version.
+
+  This program is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+  more details.
+
+  You should have received a copy of the GNU General Public License along with
+  this program; if not, write to the Free Software Foundation, Inc., 59
+  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+
+  The full GNU General Public License is included in this distribution in the
+  file called LICENSE.
+*******************************************************************************/
+
+#include "indifilterwheel.h"
+
+#include <string.h>
+
+INDI::FilterWheel::FilterWheel()
+{
+    //ctor
+    MaxFilter=12;
+}
+
+INDI::FilterWheel::~FilterWheel()
+{
+    //dtor
+}
+
+bool INDI::FilterWheel::initProperties()
+{
+    DefaultDriver::initProperties();   //  let the base class flesh in what it wants
+
+    IUFillNumber(&FilterSlotN[0],"FILTER_SLOT_VALUE","Filter","%3.0f",1.0,12.0,1.0,1.0);
+    IUFillNumberVector(&FilterSlotNV,FilterSlotN,1,deviceName(),"FILTER_SLOT","Filter","Main Control",IP_RW,60,IPS_IDLE);
+
+    IUFillText(&FilterNameT[0],"FILTER1","1","");
+    IUFillText(&FilterNameT[1],"FILTER2","2","");
+    IUFillText(&FilterNameT[2],"FILTER3","3","");
+    IUFillText(&FilterNameT[3],"FILTER4","4","");
+    IUFillText(&FilterNameT[4],"FILTER5","5","");
+    IUFillText(&FilterNameT[5],"FILTER6","6","");
+    IUFillText(&FilterNameT[6],"FILTER7","7","");
+    IUFillText(&FilterNameT[7],"FILTER8","8","");
+    IUFillText(&FilterNameT[8],"FILTER9","9","");
+    IUFillText(&FilterNameT[9],"FILTER10","10","");
+    IUFillText(&FilterNameT[10],"FILTER11","11","");
+    IUFillText(&FilterNameT[11],"FILTER12","12","");
+    IUFillTextVector(&FilterNameTV,FilterNameT,12,deviceName(),"FILTER_NAME","Filter","Filters",IP_RW,60,IPS_IDLE);
+
+    return 0;
+}
+
+void INDI::FilterWheel::ISGetProperties (const char *dev)
+{
+    //  First we let our parent populate
+    //IDLog("INDI::FilterWheel::ISGetProperties %s\n",dev);
+    DefaultDriver::ISGetProperties(dev);
+    if(isConnected())
+    {
+        defineNumber(&FilterSlotNV);
+        defineText(&FilterNameTV);
+    }
+    return;
+}
+
+bool INDI::FilterWheel::updateProperties()
+{
+    //  Define more properties after we are connected
+    //  first we want to update the values to reflect our actual wheel
+
+    if(isConnected())
+    {
+        IUFillNumber(&FilterSlotN[0],"FILTER_SLOT_VALUE","Filter","%3.0f",MinFilter,MaxFilter,1.0,CurrentFilter);
+        defineNumber(&FilterSlotNV);
+        IUFillTextVector(&FilterNameTV,FilterNameT,MaxFilter,deviceName(),"FILTER_NAME","Filter","Filters",IP_RW,60,IPS_IDLE);
+        defineText(&FilterNameTV);
+        //LoadFilterNames();
+    } else
+    {
+        deleteProperty(FilterSlotNV.name);
+        deleteProperty(FilterNameTV.name);
+    }
+
+    return true;
+}
+
+bool INDI::FilterWheel::ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n)
+{
+    //  first check if it's for our device
+    //IDLog("INDI::FilterWheel::ISNewNumber %s\n",name);
+    if(strcmp(dev,deviceName())==0) {
+        //  This is for our device
+        //  Now lets see if it's something we process here
+
+        if(strcmp(name,"FILTER_SLOT")==0) {
+
+            int f;
+
+            f=-1;
+            for(int x=0; x<n; x++) {
+                if(strcmp(names[x],"FILTER_SLOT_VALUE")==0) {
+                    //  This is the new filter number we are being asked
+                    //  to set as active
+                    f=values[x];
+                }
+            }
+
+            if(f != -1) {
+                //IDLog("Filter wheel got a filter slot change\n");
+                //  tell the client we are busy changing the filter
+                FilterSlotNV.s=IPS_BUSY;
+                IDSetNumber(&FilterSlotNV,NULL);
+                //  Tell the hardware to change
+                SelectFilter(f);
+                //  tell the caller we processed this
+                return true;
+            }
+        }
+    }
+    //  if we didn't process it, continue up the chain, let somebody else
+    //  give it a shot
+    return DefaultDriver::ISNewNumber(dev,name,values,names,n);
+}
+
+bool INDI::FilterWheel::ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n)
+{
+    //  Ok, lets see if this is a property wer process
+    //IDLog("INDI::FilterWheel got %d new text items name %s\n",n,name);
+    //  first check if it's for our device
+    if(strcmp(dev,deviceName())==0) {
+        //  This is for our device
+        //  Now lets see if it's something we process here
+        if(strcmp(name,FilterNameTV.name)==0) {
+            //  This is our port, so, lets process it
+
+            //  Some clients insist on sending a port
+            //  and they may not be configured for the
+            //  correct port
+            //  If we are already connected
+            //  and running, it makes absolutely no sense
+            //  to accept a new port value
+            //  so lets just lie to them and say
+            //  we did this, but, dont actually change anything
+            //if(Connected) return true;
+
+            int rc;
+            //IDLog("calling update text\n");
+            FilterNameTV.s=IPS_OK;
+            rc=IUUpdateText(&FilterNameTV,texts,names,n);
+            //IDLog("update text returns %d\n",rc);
+            //  Update client display
+            IDSetText(&FilterNameTV,NULL);
+            //SaveConfig();
+
+            //  We processed this one, so, tell the world we did it
+            return true;
+        }
+
+    }
+
+    return DefaultDriver::ISNewText(dev,name,texts,names,n);
+}
+
+int INDI::FilterWheel::SelectFilterDone(int f)
+{
+    //  The hardware has finished changing
+    //  filters
+    FilterSlotN[0].value=f;
+    FilterSlotNV.s=IPS_OK;
+    // Tell the clients we are done, and
+    //  filter is now useable
+    IDSetNumber(&FilterSlotNV,NULL);
+    return 0;
+}
+
+int INDI::FilterWheel::SelectFilter(int)
+{
+    return -1;
+}
+
+int INDI::FilterWheel::QueryFilter()
+{
+    return -1;
+}
+
+
Index: /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.h	(revision 504)
+++ /BAORadio/libindi/libindi/libs/indibase/indifilterwheel.h	(revision 504)
@@ -0,0 +1,66 @@
+/*******************************************************************************
+  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+
+  This program is free software; you can redistribute it and/or modify it
+  under the terms of the GNU General Public License as published by the Free
+  Software Foundation; either version 2 of the License, or (at your option)
+  any later version.
+
+  This program is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+  more details.
+
+  You should have received a copy of the GNU General Public License along with
+  this program; if not, write to the Free Software Foundation, Inc., 59
+  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+
+  The full GNU General Public License is included in this distribution in the
+  file called LICENSE.
+*******************************************************************************/
+#ifndef INDI_FILTERWHEEL_H
+#define INDI_FILTERWHEEL_H
+
+#include "defaultdriver.h"
+
+class INDI::FilterWheel: public INDI::DefaultDriver
+{
+    protected:
+    private:
+
+    public:
+        FilterWheel();
+        virtual ~FilterWheel();
+
+        INumberVectorProperty FilterSlotNV;   //  A number vector for filter slot
+        INumber FilterSlotN[1];
+
+        ITextVectorProperty FilterNameTV; //  A text vector that stores out physical port name
+        IText FilterNameT[12];
+
+        int MinFilter;
+        int MaxFilter;
+        int CurrentFilter;
+        int TargetFilter;
+
+
+        virtual bool initProperties();
+        virtual bool updateProperties();
+        virtual void ISGetProperties (const char *dev);
+
+        //  Ok, we do need our virtual functions from the base class for processing
+        //  client requests
+        //  We process Numbers and text in a filter wheel
+        virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
+        virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);
+        virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n) { return false; }
+
+        virtual int SelectFilter(int);
+        virtual int SelectFilterDone(int);
+        virtual int QueryFilter();
+        //int SaveFilterNames();
+        //int LoadFilterNames();
+
+};
+
+#endif // INDI::FilterWheel_H
